<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>AccountResource.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.web.rest</a> &gt; <span class="el_source">AccountResource.java</span></div><h1>AccountResource.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.web.rest;

import com.codahale.metrics.annotation.Timed;

import br.edu.unifacisa.lti.domain.User;
import br.edu.unifacisa.lti.repository.UserRepository;
import br.edu.unifacisa.lti.security.SecurityUtils;
import br.edu.unifacisa.lti.service.MailService;
import br.edu.unifacisa.lti.service.UserService;
import br.edu.unifacisa.lti.service.dto.UserDTO;
import br.edu.unifacisa.lti.web.rest.vm.KeyAndPasswordVM;
import br.edu.unifacisa.lti.web.rest.vm.ManagedUserVM;
import br.edu.unifacisa.lti.web.rest.util.HeaderUtil;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.*;

/**
 * REST controller for managing the current user's account.
 */
@RestController
@RequestMapping(&quot;/api&quot;)
public class AccountResource {

<span class="fc" id="L35">    private final Logger log = LoggerFactory.getLogger(AccountResource.class);</span>

    private final UserRepository userRepository;

    private final UserService userService;

    private final MailService mailService;

    public AccountResource(UserRepository userRepository, UserService userService,
<span class="fc" id="L44">            MailService mailService) {</span>

<span class="fc" id="L46">        this.userRepository = userRepository;</span>
<span class="fc" id="L47">        this.userService = userService;</span>
<span class="fc" id="L48">        this.mailService = mailService;</span>
<span class="fc" id="L49">    }</span>

    /**
     * POST  /register : register the user.
     *
     * @param managedUserVM the managed user View Model
     * @return the ResponseEntity with status 201 (Created) if the user is registered or 400 (Bad Request) if the login or email is already in use
     */
    @PostMapping(path = &quot;/register&quot;,
                    produces={MediaType.APPLICATION_JSON_VALUE, MediaType.TEXT_PLAIN_VALUE})
    @Timed
    public ResponseEntity registerAccount(@Valid @RequestBody ManagedUserVM managedUserVM) {

<span class="fc" id="L62">        HttpHeaders textPlainHeaders = new HttpHeaders();</span>
<span class="fc" id="L63">        textPlainHeaders.setContentType(MediaType.TEXT_PLAIN);</span>

<span class="fc" id="L65">        return userRepository.findOneByLogin(managedUserVM.getLogin().toLowerCase())</span>
<span class="fc" id="L66">            .map(user -&gt; new ResponseEntity&lt;&gt;(&quot;login already in use&quot;, textPlainHeaders, HttpStatus.BAD_REQUEST))</span>
<span class="fc" id="L67">            .orElseGet(() -&gt; userRepository.findOneByEmail(managedUserVM.getEmail())</span>
<span class="fc" id="L68">                .map(user -&gt; new ResponseEntity&lt;&gt;(&quot;email address already in use&quot;, textPlainHeaders, HttpStatus.BAD_REQUEST))</span>
<span class="fc" id="L69">                .orElseGet(() -&gt; {</span>
<span class="fc" id="L70">                    User user = userService</span>
<span class="fc" id="L71">                        .createUser(managedUserVM.getLogin(), managedUserVM.getPassword(),</span>
<span class="fc" id="L72">                            managedUserVM.getFirstName(), managedUserVM.getLastName(),</span>
<span class="fc" id="L73">                            managedUserVM.getEmail().toLowerCase(), managedUserVM.getImageUrl(), managedUserVM.getLangKey());</span>

<span class="fc" id="L75">                    mailService.sendActivationEmail(user);</span>
<span class="fc" id="L76">                    return new ResponseEntity&lt;&gt;(HttpStatus.CREATED);</span>
                })
        );
    }

    /**
     * GET  /activate : activate the registered user.
     *
     * @param key the activation key
     * @return the ResponseEntity with status 200 (OK) and the activated user in body, or status 500 (Internal Server Error) if the user couldn't be activated
     */
    @GetMapping(&quot;/activate&quot;)
    @Timed
    public ResponseEntity&lt;String&gt; activateAccount(@RequestParam(value = &quot;key&quot;) String key) {
<span class="nc" id="L90">        return userService.activateRegistration(key)</span>
<span class="nc" id="L91">            .map(user -&gt; new ResponseEntity&lt;String&gt;(HttpStatus.OK))</span>
<span class="nc" id="L92">            .orElse(new ResponseEntity&lt;&gt;(HttpStatus.INTERNAL_SERVER_ERROR));</span>
    }

    /**
     * GET  /authenticate : check if the user is authenticated, and return its login.
     *
     * @param request the HTTP request
     * @return the login if the user is authenticated
     */
    @GetMapping(&quot;/authenticate&quot;)
    @Timed
    public String isAuthenticated(HttpServletRequest request) {
<span class="fc" id="L104">        log.debug(&quot;REST request to check if the current user is authenticated&quot;);</span>
<span class="fc" id="L105">        return request.getRemoteUser();</span>
    }

    /**
     * GET  /account : get the current user.
     *
     * @return the ResponseEntity with status 200 (OK) and the current user in body, or status 500 (Internal Server Error) if the user couldn't be returned
     */
    @GetMapping(&quot;/account&quot;)
    @Timed
    public ResponseEntity&lt;UserDTO&gt; getAccount() {
<span class="fc" id="L116">        return Optional.ofNullable(userService.getUserWithAuthorities())</span>
<span class="fc" id="L117">            .map(user -&gt; new ResponseEntity&lt;&gt;(new UserDTO(user), HttpStatus.OK))</span>
<span class="fc" id="L118">            .orElse(new ResponseEntity&lt;&gt;(HttpStatus.INTERNAL_SERVER_ERROR));</span>
    }

    /**
     * POST  /account : update the current user information.
     *
     * @param userDTO the current user information
     * @return the ResponseEntity with status 200 (OK), or status 400 (Bad Request) or 500 (Internal Server Error) if the user couldn't be updated
     */
    @PostMapping(&quot;/account&quot;)
    @Timed
    public ResponseEntity saveAccount(@Valid @RequestBody UserDTO userDTO) {
<span class="nc" id="L130">        Optional&lt;User&gt; existingUser = userRepository.findOneByEmail(userDTO.getEmail());</span>
<span class="nc bnc" id="L131" title="All 4 branches missed.">        if (existingUser.isPresent() &amp;&amp; (!existingUser.get().getLogin().equalsIgnoreCase(userDTO.getLogin()))) {</span>
<span class="nc" id="L132">            return ResponseEntity.badRequest().headers(HeaderUtil.createFailureAlert(&quot;user-management&quot;, &quot;emailexists&quot;, &quot;Email already in use&quot;)).body(null);</span>
        }
<span class="nc" id="L134">        return userRepository</span>
<span class="nc" id="L135">            .findOneByLogin(SecurityUtils.getCurrentUserLogin())</span>
<span class="nc" id="L136">            .map(u -&gt; {</span>
<span class="nc" id="L137">                userService.updateUser(userDTO.getFirstName(), userDTO.getLastName(), userDTO.getEmail(),</span>
<span class="nc" id="L138">                    userDTO.getLangKey(), userDTO.getImageUrl());</span>
<span class="nc" id="L139">                return new ResponseEntity(HttpStatus.OK);</span>
            })
<span class="nc" id="L141">            .orElseGet(() -&gt; new ResponseEntity&lt;&gt;(HttpStatus.INTERNAL_SERVER_ERROR));</span>
    }

    /**
     * POST  /account/change_password : changes the current user's password
     *
     * @param password the new password
     * @return the ResponseEntity with status 200 (OK), or status 400 (Bad Request) if the new password is not strong enough
     */
    @PostMapping(path = &quot;/account/change_password&quot;,
        produces = MediaType.TEXT_PLAIN_VALUE)
    @Timed
    public ResponseEntity changePassword(@RequestBody String password) {
<span class="nc bnc" id="L154" title="All 2 branches missed.">        if (!checkPasswordLength(password)) {</span>
<span class="nc" id="L155">            return new ResponseEntity&lt;&gt;(&quot;Incorrect password&quot;, HttpStatus.BAD_REQUEST);</span>
        }
<span class="nc" id="L157">        userService.changePassword(password);</span>
<span class="nc" id="L158">        return new ResponseEntity&lt;&gt;(HttpStatus.OK);</span>
    }

    /**
     * POST   /account/reset_password/init : Send an email to reset the password of the user
     *
     * @param mail the mail of the user
     * @return the ResponseEntity with status 200 (OK) if the email was sent, or status 400 (Bad Request) if the email address is not registered
     */
    @PostMapping(path = &quot;/account/reset_password/init&quot;,
        produces = MediaType.TEXT_PLAIN_VALUE)
    @Timed
    public ResponseEntity requestPasswordReset(@RequestBody String mail) {
<span class="nc" id="L171">        return userService.requestPasswordReset(mail)</span>
<span class="nc" id="L172">            .map(user -&gt; {</span>
<span class="nc" id="L173">                mailService.sendPasswordResetMail(user);</span>
<span class="nc" id="L174">                return new ResponseEntity&lt;&gt;(&quot;email was sent&quot;, HttpStatus.OK);</span>
<span class="nc" id="L175">            }).orElse(new ResponseEntity&lt;&gt;(&quot;email address not registered&quot;, HttpStatus.BAD_REQUEST));</span>
    }

    /**
     * POST   /account/reset_password/finish : Finish to reset the password of the user
     *
     * @param keyAndPassword the generated key and the new password
     * @return the ResponseEntity with status 200 (OK) if the password has been reset,
     * or status 400 (Bad Request) or 500 (Internal Server Error) if the password could not be reset
     */
    @PostMapping(path = &quot;/account/reset_password/finish&quot;,
        produces = MediaType.TEXT_PLAIN_VALUE)
    @Timed
    public ResponseEntity&lt;String&gt; finishPasswordReset(@RequestBody KeyAndPasswordVM keyAndPassword) {
<span class="nc bnc" id="L189" title="All 2 branches missed.">        if (!checkPasswordLength(keyAndPassword.getNewPassword())) {</span>
<span class="nc" id="L190">            return new ResponseEntity&lt;&gt;(&quot;Incorrect password&quot;, HttpStatus.BAD_REQUEST);</span>
        }
<span class="nc" id="L192">        return userService.completePasswordReset(keyAndPassword.getNewPassword(), keyAndPassword.getKey())</span>
<span class="nc" id="L193">              .map(user -&gt; new ResponseEntity&lt;String&gt;(HttpStatus.OK))</span>
<span class="nc" id="L194">              .orElse(new ResponseEntity&lt;&gt;(HttpStatus.INTERNAL_SERVER_ERROR));</span>
    }

    private boolean checkPasswordLength(String password) {
<span class="nc bnc" id="L198" title="All 2 branches missed.">        return !StringUtils.isEmpty(password) &amp;&amp;</span>
<span class="nc bnc" id="L199" title="All 2 branches missed.">            password.length() &gt;= ManagedUserVM.PASSWORD_MIN_LENGTH &amp;&amp;</span>
<span class="nc bnc" id="L200" title="All 2 branches missed.">            password.length() &lt;= ManagedUserVM.PASSWORD_MAX_LENGTH;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>